/*
 * Flipdot Demo serial control
 * Copyright (C) 2013  B. Stultiens
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef __QFLIPDEMO_DIALOG_H
#define __QFLIPDEMO_DIALOG_H

#include <QDialog>

#ifdef __WIN32__
#include <windows.h>
#endif

class fdbox;
class QPushButton;
class QComboBox;
class QCheckBox;
class QTimer;

class Dialog : public QDialog
{
	Q_OBJECT

public:
	Dialog();

private:
	QComboBox	*port;

	QCheckBox	*autoflip;
	fdbox		*flipdots[7];

	bool	portisopen;
#ifdef __WIN32__
	HANDLE	serfd;
#else
	int	serfd;
#endif
	QTimer		*reenumtmr;
	QTimer		*autotmr;
	QTimer		*runtmr;
	QPushButton	*loader;
	QPushButton	*runner;
	QByteArray	flipdata;
	int		flipdatapos;
	QString		filedir;

	ssize_t dowrite(const void *p, size_t n);
	void openport(const char *path);
	void closeport();

public slots:
	void setport(int v);
	void enumports(bool chkd);
	void enumports();
	void fliptimeout();
	void doflip(int ch);
	void checker(int st);
	void doclose(int);
	void dohelp();
	void loadfile(bool);
	void runfile(bool);
	void runflip();
};

#endif
